<template>
    <div class="fullheight equipment-monitor-container">
        <div class="top-container">
            <div class="content-item" :class="item.key" v-for="(item, index) in equipmentStates" :key="index">
                {{ item.text }}
                <span class="item-num">{{ item.value }}</span> 台
            </div>
            <div class="collect-time">采集时间：{{ collectTime }}</div>
        </div>
        <div class="main-container" :body-style="bodyStyle2">
            <el-scrollbar class="editScroll">
                <div class="col-container">
                    <div class="collapse-container" v-for="(value, key, index) in crewCol" :key="index">
                        <el-collapse class="collapse-crew-item" accordion v-for="(crewL, ii) in value.crewList"
                            :key="ii" v-model="crewL.activeNames">
                            <el-collapse-item :name="crewL.fanCode">
                                <template slot="title">
                                    <div class="header-name">
                                        <span class="header-name-left">
                                            <span>{{ crewL.fanName }}</span>
                                            <img class="crew-img" :src="require('@/assets/img/crew-white.png')" />
                                        </span>
                                        <span class="header-btn" @click.stop="toggleExpand(key, ii)">
                                            {{ crewL.isExpand ? '全部收起' : '全部展开' }}
                                        </span>
                                    </div>
                                </template>
                                <div class="collapse-part-item">
                                    <el-collapse v-for="(partL, i) in crewL.partList" :key="i"
                                        v-model="partL.innerActiveNames"
                                        @change="(val) => handleChangeItem(val, key, ii, partL.key)">
                                        <el-collapse-item :name="partL.key">
                                            <template slot="title">
                                                <span class="header-name">{{ partL.name }}</span>
                                            </template>
                                            <div v-for="(
                                                    item, index
                                                ) in partL.data" :key="index" class="part-item">
                                                <span>{{ item.positon_name }}</span>
                                                <span>{{ item.position_state | state }}</span>
                                            </div>
                                        </el-collapse-item>
                                    </el-collapse>
                                </div>
                            </el-collapse-item>
                        </el-collapse>
                    </div>
                </div>
            </el-scrollbar>
        </div>
    </div>
</template>
<script>
export default {
    name: 'equipment-monitor',
    data() {
        return {
            collectTime: '',
            timer: null,
            bodyStyle: {
                padding: '10px 20px',
            },
            bodyStyle2: {
                padding: '10px',
                height: 'calc(100% - 20px)',
            },
            equipmentStates: [
                { key: 'normal', value: 0, text: '正常风机' },
                { key: 'warm', value: 0, text: '预警风机' },
                { key: 'alarm', value: 0, text: '报警风机' },
                // {key: 'abnormal', value: 0, text: '通讯异常风机'},
            ],
            ListData: [],
            crewCol: {
                col1: {
                    crewList: [
                        // {
                        //     name: '#00001',
                        //     isExpand: false,
                        //     activeNames: [],
                        //     innerActiveKeys: {},
                        //     partList: [
                        //         {
                        //             innerActiveNames: [],
                        //             key: 'col2-key1',
                        //             name: '传动链',
                        //             data: [
                        //                 {
                        //                     key: '主轴前轴承径向',
                        //                     value: '正常',
                        //                 },
                        //                 {
                        //                     key: '发动机驱动端径向',
                        //                     value: '正常',
                        //                 },
                        //             ],
                        //         },
                        //     ],
                        // },
                    ],
                },
                col2: {
                    crewList: [],
                },
                col3: {
                    crewList: [],
                },
                col4: {
                    crewList: [],
                },
            },
        }
    },
    filters: {
        state: (value) => {
            if (value == 1) {
                return '正常'
            } else if (value == 2) {
                return '预警'
            } else if (value == 3) {
                return '报警'
            }
        },
    },
    mounted() {
        this.initData()
        this.circlrQuery()
    },
    beforeDestroy() {
        clearInterval(this.timer)
    },
    methods: {
        circlrQuery() {
            clearInterval(this.timer)
            this.timer = setInterval(() => {
                this.clearData()
                this.initData()
                this.circlrQuery()
            }, 1000 * 60 * 5)
        },
        clearData() {
            this.ListData = []
            this.crewCol = {
                col1: {
                    crewList: [],
                },
                col2: {
                    crewList: [],
                },
                col3: {
                    crewList: [],
                },
                col4: {
                    crewList: [],
                },
            }
            this.equipmentStates[0].value = 0
            this.equipmentStates[1].value = 0
            this.equipmentStates[2].value = 0
        },
        initData() {
            this.$http.post('${cssc}/biz/cms/cmsState/v1/queryNoPage').then((res) => {
                if (res.status == 200) {
                    this.ListData = res.data
                    console.log(this.ListData)
                    this.collectTime = this.ListData[0].collTime
                    this.ListData.forEach((item, index) => {
                        if (item.fanState == 1) {
                            this.equipmentStates[0].value++
                        } else if (item.fanState == 2) {
                            this.equipmentStates[1].value++
                        } else if (item.fanState == 3) {
                            this.equipmentStates[2].value++
                        }

                        item.isExpand = false
                        item.activeNames = []
                        item.innerActiveKeys = {}
                        item.partList = []
                        let item1 = {
                            key: '',
                            name: '传动链振动',
                            data: JSON.parse(item.driveChain),
                            innerActiveNames: [],
                        }
                        let item2 = {
                            key: '',
                            name: '倾角数据',
                            data: JSON.parse(item.towerBaseObliquity),
                            innerActiveNames: [],
                        }
                        // console.log(item)
                        if (index % 4 == 0) {
                            item1.key = 'col1-key1'
                            item2.key = 'col1-key2'
                            item.innerActiveKeys = {
                                [item1.key]: false,
                                [item2.key]: false,
                            }
                            item.partList.push(item1, item2)
                            this.crewCol.col1.crewList.push(item)
                        } else if (index % 4 == 1) {
                            item1.key = 'col2-key1'
                            item2.key = 'col2-key2'
                            item.innerActiveKeys = {
                                [item1.key]: false,
                                [item2.key]: false,
                            }
                            item.partList.push(item1, item2)
                            this.crewCol.col2.crewList.push(item)
                        } else if (index % 4 == 2) {
                            item1.key = 'col3-key1'
                            item2.key = 'col3-key2'
                            item.innerActiveKeys = {
                                [item1.key]: false,
                                [item2.key]: false,
                            }
                            item.partList.push(item1, item2)
                            this.crewCol.col3.crewList.push(item)
                        } else if (index % 4 == 3) {
                            item1.key = 'col3-key1'
                            item2.key = 'col3-key2'
                            item.innerActiveKeys = {
                                [item1.key]: false,
                                [item2.key]: false,
                            }
                            item.partList.push(item1, item2)
                            this.crewCol.col4.crewList.push(item)
                        }
                    })
                }
            })
        },
        toggleExpand(key, i) {
            if (this.crewCol[key].crewList[i].isExpand) {
                this.crewCol[key].crewList[i].activeNames = []
                Object.keys(
                    this.crewCol[key].crewList[i].innerActiveKeys
                ).forEach((keyname) => {
                    this.crewCol[key].crewList[i].innerActiveKeys[
                        keyname
                    ] = false
                })
                this.crewCol[key].crewList[i].partList.forEach(
                    (part) => (part.innerActiveNames = [])
                )
            } else {
                this.crewCol[key].crewList[i].activeNames = [
                    this.crewCol[key].crewList[i].fanCode,
                ]
                this.crewCol[key].crewList[i].partList.forEach((part) => {
                    part.innerActiveNames = this.crewCol[key].crewList[
                        i
                    ].partList.map((item) => {
                        return item.key
                    })
                })
                Object.keys(
                    this.crewCol[key].crewList[i].innerActiveKeys
                ).forEach((keyname) => {
                    this.crewCol[key].crewList[i].innerActiveKeys[
                        keyname
                    ] = true
                })
            }
            this.crewCol[key].crewList[i].isExpand =
                !this.crewCol[key].crewList[i].isExpand
            console.log(key, i, this.crewCol[key].crewList[i])
            this.$forceUpdate()
        },
        handleChangeItem(val, key, i, currentKey) {
            if (val.length) {
                let keysObj = this.crewCol[key].crewList[i].innerActiveKeys
                keysObj[val[0]] = true
                let arr = []
                for (let keyName in keysObj) {
                    if (!keysObj[keyName]) {
                        this.crewCol[key].crewList[i].isExpand = false
                    } else {
                        arr.push(keyName)
                    }
                }
                if (arr.length == Object.keys(keysObj).length) {
                    this.crewCol[key].crewList[i].isExpand = true
                }
            } else {
                this.crewCol[key].crewList[i].innerActiveKeys[
                    currentKey
                ] = false
                this.crewCol[key].crewList[i].isExpand = false
            }
            this.$forceUpdate()
        },
    },
}
</script>
<style lang="scss" scoped>
@import '@/assets/css/element-variables.scss';

.equipment-monitor-container {
    width: 100%;
    box-sizing: border-box;

    .top-container {
        width: 100%;
        height: 54px;
        box-sizing: border-box;
        border: 1px solid #145d77;
        background: #0f475b;
        display: flex;
        justify-content: center;
        align-items: center;
        position: relative;

        .content-item {
            margin: 0 36px;
            padding: 6px 40px;
            color: $--color-text;
            font-weight: bold;
            font-size: 14px;
        }

        .item-num {
            font-size: 16px;
            padding: 0 6px;
        }

        .content-item.normal {
            background: $--color-success;
        }

        .content-item.warm {
            background: $--color-warning;
        }

        .content-item.alarm {
            background: $--color-danger;
        }

        .content-item.abnormal {
            background: $--color-info;
        }
    }

    .main-container {
        margin-top: 10px;
        height: calc(100% - 66px);
    }

    .col-container {
        width: 100%;
        height: 100%;
        display: flex;
        justify-content: space-around;
    }

    .collapse-container {
        width: calc(25% - 10px);
        box-sizing: border-box;
        height: 100%;

        /deep/ .el-collapse-item__arrow {
            order: 1;
            margin: 0 8px 0 8px;
        }

        .collapse-crew-item {
            width: 100%;
            margin: 0 auto;
            box-sizing: border-box;
            margin-bottom: 10px;
            border: 1px solid #145d77;

            /deep/.el-collapse-item__header {
                // background-color: $--border-color-lighter;
                border-bottom: 1px solid #145d77;
                background-color: #0f475b;
                color: $--color-text;
            }

            /deep/.el-collapse-item__header.is-active {
                border-bottom-color: #25b4be;
                color: #fff;
                font-weight: bold;
                // background-color: rgba($--color-primary, 0.6);
                background-color: #25b4be;
            }

            /deep/.el-collapse-item__content {
                padding-bottom: 0;
                background-color: #25b4be;
                color: $--color-text-dark;
            }

            /deep/.el-collapse-item__wrap {
                border-bottom: 1px solid #145d77;
            }
        }

        .collapse-crew-item:last-of-type {
            margin-bottom: 0;
        }

        .collapse-part-item {
            width: 90%;
            margin: 0 auto;

            /deep/ .el-collapse-item__wrap {
                border-bottom: 0;
            }

            /deep/ .el-collapse {
                border-top: 0;
                border-bottom: 0;
            }

            /deep/ .el-collapse-item__header {
                background-color: #25b4be;
            }

            /deep/.el-collapse-item__header.is-active {
                background-color: #25b4be;
                // color:#303133;
                color: #fff;
            }

            /deep/.el-collapse-item__content {
                padding: 10px 0;
                color: #fff;
            }

            .part-item {
                display: flex;
                justify-content: space-between;
                padding: 4px 10px;
            }
        }

        .header-name {
            order: 2;
            display: inline-block;
            width: calc(100% - 40px);
            display: flex;
            justify-content: space-between;
            align-items: center;
        }

        .header-name-left {
            display: flex;
            align-items: center;
        }

        .crew-img {
            width: 20px;
            margin-left: 10px;
        }
    }

    .editScroll {
        height: 100% !important;
        overflow-x: hidden;

        /deep/ .el-scrollbar__wrap {
            overflow-x: hidden;
        }
    }

    .collect-time {
        position: absolute;
        right: 20px;
        // top: 10px;
        background-color: #25b4be;
        padding: 6px 10px;
    }
}
</style>
